<< ../main/oneloop.m;

(* hexagon function with IR singularities

               p3(mb)
  p1(ma) _______|_______ p4(mb)
           | 0    mb |
         ma|         |0
  p2(ma) __|_________|__ p5(mc)
             0  | mc
	       p6(mc)
*)
hden = {k1.k1 - ma, 
        (k1+p1).(k1+p1),
	(k1+p1-p3).(k1+p1-p3) - mb,
	(k1+p1-p3-p4).(k1+p1-p3-p4),
	(k1+p1-p3-p4-p5).(k1+p1-p3-p4-p5) - mc,
	(k1-p2).(k1-p2)};
hnum = 1;

pars = {ma,mb,mc,s,s13,s14,s15,s23,s24,s25,s34,s35};
momext = {p1,p2,p3,p4,p5,p6};
rels = {Dot[p1,p1]->ma, Dot[p2,p2]->ma, Dot[p3,p3]->mb, Dot[p4,p4]->mb,
	Dot[p5,p5]->mc, Dot[p6,p6]->mc,
	Dot[p1,p2]->s/2-ma, 
	Dot[p1,p3]->-s13/2+ma/2+mb/2,
	Dot[p1,p4]->-s14/2+ma/2+mb/2,
	Dot[p1,p5]->-s15/2+ma/2+mc/2,
	Dot[p2,p3]->-s23/2+ma/2+mb/2,
	Dot[p2,p4]->-s24/2+ma/2+mb/2,
	Dot[p2,p5]->-s25/2+ma/2+mc/2,
	Dot[p3,p4]->s34/2-mb,
	Dot[p3,p5]->s35/2-mb/2-mc/2,
	Dot[p4,p5]->(6*ma+5*mb+3*mc-s-s13-s14-s15-s23-s24-s25-s34-s35)/2};

hnum = SubSoft[hden, hnum, k1, k1+p1];
hnum = SubSoft[hden, hnum, k1, k1+p1-p3-p4];
hnum = SubSoft[hden, hnum, k1, k1-p2];
hex = OneLoop[hden, hnum, k1, SimpLevel->2, NestedExpressions->True];
WriteCode[hex, Deform->True, SimpFunc->Identity, WorkingDirectory->"hexagon1"];

(* sample numbers:
   ma^2 = 1
   mb^2 = 0.25
   mc^2 = 4
   p1 = {0,0,3}
   p2 = {0,0,-3}
   p3 = {0.5,0,0.5}
   p4 = {-0.2,0,0.1}
   p5 = {0,1.37626,-0.3}
   p6 = {-0.3,-1.37626,-0.3}
   s = 40
   s13 = -1.22723
   s14 = -1.61410
   s15 = -12.2714
   s23 = -7.22723
   s24 = -2.81410
   s25 = -8.67138
   s34 = 1.54868 
   s35 = 8.78701
*)
